package com.logicbig.function;


import java.util.Currency;
import java.util.Locale;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;


/**
 * In this example we pass a Supplier instance via lambda expression to displayCurrencyCode method,
 * beside use of lambda this example also shows how we can separate concerns via Supplier pattern.
 * In real application, we want to keep displaying/renderer and retrieving currency code logic
 * separated.
 */
public class SupplierExample {

    public static void main (String[] args) {

        displayCurrencyCode(() -> Currency.getInstance(Locale.CHINA)
                                          .getCurrencyCode());

    }

    public static void displayCurrencyCode (Supplier<String> currencyCodeSupplier) {
        System.out.println(currencyCodeSupplier.get());
    }
}